import type { NodePath } from '@babel/core';
import * as t from '@babel/types';
import type { Metadata } from '../types';
/**
 * Takes a class name component and transforms it into a compiled component.
 * This method will traverse the AST twice,
 * once to replace all calls to `css`,
 * and another to replace `style` usage.
 *
 * `<ClassNames>{}</ClassNames>`
 *
 * @param path {NodePath} The opening JSX element
 * @param meta {Metadata} Useful metadata that can be used during the transformation
 */
export declare const visitClassNamesPath: (path: NodePath<t.JSXElement>, meta: Metadata) => void;
