import type { NodePath } from '@babel/core';
import * as t from '@babel/types';
import type { Metadata } from '../types';
/**
 * Takes a JSX opening element and then transforms any usage of `css` prop to a compiled component.
 *
 * `<div css={{}}>`
 *
 * @param path {NodePath} The opening JSX element
 * @param meta {Metadata} Useful metadata that can be used during the transformation
 */
export declare const visitCssPropPath: (path: NodePath<t.JSXOpeningElement>, meta: Metadata) => void;
