import type { NodePath } from '@babel/core';
import * as t from '@babel/types';
import type { Metadata } from '../types';
/**
 * Takes a styled tagged template or call expression and then transforms it to a compiled component.
 *
 * `styled.div({})`
 *
 * @param path {NodePath} The tagged template or call expression
 * @param meta {Metadata} Useful metadata that can be used during the transformation
 */
export declare const visitStyledPath: (path: NodePath<t.TaggedTemplateExpression> | NodePath<t.CallExpression>, meta: Metadata) => void;
