"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transform = void 0;
var core_1 = require("@babel/core");
var prettier_1 = require("prettier");
var babel_plugin_1 = __importDefault(require("./babel-plugin"));
var transform = function (code, options) {
    if (options === void 0) { options = {}; }
    var _a = options.comments, comments = _a === void 0 ? false : _a, filename = options.filename, highlightCode = options.highlightCode, _b = options.pretty, pretty = _b === void 0 ? true : _b, snippet = options.snippet, pluginOptions = __rest(options, ["comments", "filename", "highlightCode", "pretty", "snippet"]);
    var fileResult = (0, core_1.transformSync)(code, {
        babelrc: false,
        comments: comments,
        compact: !pretty,
        configFile: false,
        filename: filename,
        highlightCode: highlightCode,
        plugins: [[babel_plugin_1.default, pluginOptions]],
        presets: pluginOptions.importReact === false
            ? [['@babel/preset-react', { runtime: 'automatic' }]]
            : [],
    });
    if (!fileResult || !fileResult.code) {
        return '';
    }
    var babelCode = fileResult.code;
    var codeSnippet;
    if (snippet) {
        var ifIndex = babelCode.indexOf('if (process.env.NODE_ENV');
        // Remove the imports from the code, and the styled components display name
        codeSnippet = babelCode
            .substring(babelCode.indexOf('const'), ifIndex === -1 ? babelCode.length : ifIndex)
            .trim();
    }
    else {
        codeSnippet = babelCode;
    }
    return pretty ? (0, prettier_1.format)(codeSnippet, { parser: 'babel' }) : codeSnippet;
};
exports.transform = transform;
//# sourceMappingURL=test-utils.js.map