"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildDisplayName = void 0;
var template_1 = __importDefault(require("@babel/template"));
var displayNameTemplate = (0, template_1.default)("\nif (process.env.NODE_ENV !== 'production') {\n  %%identifier%%.displayName = %%displayName%%;\n}\n", { syntacticPlaceholders: true });
/**
 * Assigns a display name string to the identifier.
 *
 * @param identifier
 * @param displayName
 * @returns
 */
var buildDisplayName = function (identifier, displayName) {
    if (displayName === void 0) { displayName = identifier; }
    return displayNameTemplate({
        identifier: identifier,
        displayName: "'".concat(displayName, "'"),
    });
};
exports.buildDisplayName = buildDisplayName;
//# sourceMappingURL=build-display-name.js.map