import * as t from '@babel/types';
import type { Metadata } from '../types';
import { createResultPair } from './create-result-pair';
/**
 * Will look in an expression and return the actual value along with updated metadata.
 * If the expression is an identifier node (a variable) and a constant,
 * it will return the variable reference.
 *
 * E.g: If there was a identifier called `color` that is set somewhere as `const color = 'blue'`,
 * passing the `color` identifier to this function would return `'blue'`.
 *
 * This behaviour is the same for const string & numeric literals,
 * and object expressions.
 *
 * @param expression Expression we want to interrogate.
 * @param meta {Metadata} Useful metadata that can be used during the transformation
 */
export declare const evaluateExpression: (expression: t.Expression, meta: Metadata) => ReturnType<typeof createResultPair>;
